﻿/// <reference path="../Scripts/msls.js" />

window.myapp = msls.application;

(function (lightSwitchApplication) {

    var $Entity = msls.Entity,
        $DataService = msls.DataService,
        $DataWorkspace = msls.DataWorkspace,
        $defineEntity = msls._defineEntity,
        $defineDataService = msls._defineDataService,
        $defineDataWorkspace = msls._defineDataWorkspace,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString;

    function Range(entitySet) {
        /// <summary>
        /// Represents the Range entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this range.
        /// </param>
        /// <field name="Id" type="Number">
        /// Gets or sets the id for this range.
        /// </field>
        /// <field name="xName" type="Date">
        /// Gets or sets the xName for this range.
        /// </field>
        /// <field name="yName" type="Number">
        /// Gets or sets the yName for this range.
        /// </field>
        /// <field name="CreatedBy" type="String">
        /// Gets or sets the createdBy for this range.
        /// </field>
        /// <field name="Created" type="Date">
        /// Gets or sets the created for this range.
        /// </field>
        /// <field name="ModifiedBy" type="String">
        /// Gets or sets the modifiedBy for this range.
        /// </field>
        /// <field name="Modified" type="Date">
        /// Gets or sets the modified for this range.
        /// </field>
        /// <field name="RowVersion" type="Array">
        /// Gets or sets the rowVersion for this range.
        /// </field>
        /// <field name="details" type="msls.application.Range.Details">
        /// Gets the details for this range.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function ApplicationData(dataWorkspace) {
        /// <summary>
        /// Represents the ApplicationData data service.
        /// </summary>
        /// <param name="dataWorkspace" type="msls.DataWorkspace">
        /// The data workspace that created this data service.
        /// </param>
        /// <field name="Ranges" type="msls.EntitySet">
        /// Gets the Ranges entity set.
        /// </field>
        /// <field name="details" type="msls.application.ApplicationData.Details">
        /// Gets the details for this data service.
        /// </field>
        $DataService.call(this, dataWorkspace);
    };
    function DataWorkspace() {
        /// <summary>
        /// Represents the data workspace.
        /// </summary>
        /// <field name="ApplicationData" type="msls.application.ApplicationData">
        /// Gets the ApplicationData data service.
        /// </field>
        /// <field name="details" type="msls.application.DataWorkspace.Details">
        /// Gets the details for this data workspace.
        /// </field>
        $DataWorkspace.call(this);
    };

    msls._addToNamespace("msls.application", {

        Range: $defineEntity(Range, [
            { name: "Id", type: Number },
            { name: "xName", type: Date },
            { name: "yName", type: Number },
            { name: "CreatedBy", type: String, isReadOnly: true },
            { name: "Created", type: Date, isReadOnly: true },
            { name: "ModifiedBy", type: String, isReadOnly: true },
            { name: "Modified", type: Date, isReadOnly: true },
            { name: "RowVersion", type: Array }
        ]),

        ApplicationData: $defineDataService(ApplicationData, lightSwitchApplication.rootUri + "/ApplicationData.svc", [
            { name: "Ranges", elementType: Range }
        ], [
            {
                name: "Ranges_SingleOrDefault", value: function (Id) {
                    return new $DataServiceQuery({ _entitySet: this.Ranges },
                        lightSwitchApplication.rootUri + "/ApplicationData.svc" + "/Ranges(" + "Id=" + $toODataString(Id, "Int32?") + ")"
                    );
                }
            }
        ]),

        DataWorkspace: $defineDataWorkspace(DataWorkspace, [
            { name: "ApplicationData", type: ApplicationData }
        ])

    });

}(msls.application));
