﻿/// <reference path="data.js" />

(function (lightSwitchApplication) {

    var $Screen = msls.Screen,
        $defineScreen = msls._defineScreen,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString,
        $defineShowScreen = msls._defineShowScreen;

    function AddEditChart(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditChart screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditChart.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditChart", parameters);
    }

    function BrowseCharts(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseCharts screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Ranges" type="msls.VisualCollection" elementType="msls.application.Range">
        /// Gets the ranges for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseCharts.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseCharts", parameters);
    }

    function BrowseRangeNavicators(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseRangeNavicators screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Ranges" type="msls.VisualCollection" elementType="msls.application.Range">
        /// Gets the ranges for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseRangeNavicators.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseRangeNavicators", parameters);
    }

    function AddEditRange(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditRange screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditRange.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditRange", parameters);
    }

    function ViewRange1(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the ViewRange1 screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.ViewRange1.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "ViewRange1", parameters);
    }

    function BrowseRanges1(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseRanges1 screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Ranges" type="msls.VisualCollection" elementType="msls.application.Range">
        /// Gets the ranges for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseRanges1.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseRanges1", parameters);
    }

    function AddEditRange2(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditRange2 screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditRange2.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditRange2", parameters);
    }

    function ViewRange2(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the ViewRange2 screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.ViewRange2.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "ViewRange2", parameters);
    }

    function BrowseRanges2(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseRanges2 screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Ranges" type="msls.VisualCollection" elementType="msls.application.Range">
        /// Gets the ranges for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseRanges2.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseRanges2", parameters);
    }

    msls._addToNamespace("msls.application", {

        AddEditChart: $defineScreen(AddEditChart, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        BrowseCharts: $defineScreen(BrowseCharts, [
            {
                name: "Ranges", kind: "collection", elementType: lightSwitchApplication.Range,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Ranges;
                }
            }
        ], [
        ]),

        BrowseRangeNavicators: $defineScreen(BrowseRangeNavicators, [
            {
                name: "Ranges", kind: "collection", elementType: lightSwitchApplication.Range,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Ranges;
                }
            }
        ], [
        ]),

        AddEditRange: $defineScreen(AddEditRange, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        ViewRange1: $defineScreen(ViewRange1, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        BrowseRanges1: $defineScreen(BrowseRanges1, [
            {
                name: "Ranges", kind: "collection", elementType: lightSwitchApplication.Range,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Ranges;
                }
            }
        ], [
        ]),

        AddEditRange2: $defineScreen(AddEditRange2, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        ViewRange2: $defineScreen(ViewRange2, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        BrowseRanges2: $defineScreen(BrowseRanges2, [
            {
                name: "Ranges", kind: "collection", elementType: lightSwitchApplication.Range,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Ranges;
                }
            }
        ], [
        ]),

        showAddEditChart: $defineShowScreen(function showAddEditChart(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditChart screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditChart", parameters, options);
        }),

        showBrowseCharts: $defineShowScreen(function showBrowseCharts(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseCharts screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseCharts", parameters, options);
        }),

        showBrowseRangeNavicators: $defineShowScreen(function showBrowseRangeNavicators(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseRangeNavicators screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseRangeNavicators", parameters, options);
        }),

        showAddEditRange: $defineShowScreen(function showAddEditRange(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditRange screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditRange", parameters, options);
        }),

        showViewRange1: $defineShowScreen(function showViewRange1(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the ViewRange1 screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("ViewRange1", parameters, options);
        }),

        showBrowseRanges1: $defineShowScreen(function showBrowseRanges1(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseRanges1 screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseRanges1", parameters, options);
        }),

        showAddEditRange2: $defineShowScreen(function showAddEditRange2(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditRange2 screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditRange2", parameters, options);
        }),

        showViewRange2: $defineShowScreen(function showViewRange2(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the ViewRange2 screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("ViewRange2", parameters, options);
        }),

        showBrowseRanges2: $defineShowScreen(function showBrowseRanges2(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseRanges2 screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseRanges2", parameters, options);
        })

    });

}(msls.application));
